## elektra 0.8.7

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

project (Elektra)

#additional modules for loading libraries
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")


#needed by ifs below
include (cmake/ElektraCache.cmake)
include (cmake/ElektraCompiling.cmake)
if (ENABLE_COVERAGE)
	include (cmake/ElektraCoverage.cmake)
endif (ENABLE_COVERAGE)

if (ENABLE_TESTING)
	enable_testing ()
	include (Dart)
endif (ENABLE_TESTING)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	if (NOT FORCE_IN_SOURCE_BUILD)
		message(FATAL_ERROR
				"In-source builds are not permitted.\n"
				"Make a separate folder for building:\n"
				"    mkdir build && cd build && cmake ..\n"
				"Before that, remove the files already created:\n"
				"    rm -rf CMakeCache.txt CMakeFiles\n"
				"If you really know what you are doing\n"
				"(will overwrite original files!) use:\n"
				"    cmake -DFORCE_IN_SOURCE_BUILD=ON\n"
			)
	endif (NOT FORCE_IN_SOURCE_BUILD)
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

if (NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif (NOT CMAKE_BUILD_TYPE)


#some basic and important variables
set (DOMAIN libelektra.org) #needed by doxygen
set (REVERSE_DOMAIN org.libelektra)

set (KDB_VERSION_MAJOR 0)
set (KDB_VERSION_MINOR 8)
set (KDB_VERSION_MICRO 7)

set (KDB_VERSION "${KDB_VERSION_MAJOR}.${KDB_VERSION_MINOR}.${KDB_VERSION_MICRO}")

set (SO_VERSION 4)
#set (SO_VERSION_TOOLS 3)

#needs version above
include (cmake/ElektraPackaging.cmake)

#now add all directories
add_subdirectory (cmake)
add_subdirectory (src)

if (BUILD_DOCUMENTATION)
	add_subdirectory (doc)
endif (BUILD_DOCUMENTATION)

if (BUILD_TESTING)
	if (BUILD_FULL OR BUILD_STATIC)
		add_subdirectory (tests)
	else (BUILD_FULL OR BUILD_STATIC)
		message(WARNING "Requested to build testing, but is impossible because neither full or static build active")
	endif (BUILD_FULL OR BUILD_STATIC)
endif (BUILD_TESTING)

if (BUILD_FULL OR BUILD_STATIC)
	if (BUILD_EXAMPLES)
		add_subdirectory (examples)
	else (BUILD_EXAMPLES)
		message(WARNING "Requested to build examples, but is impossible because neither full or static build active")
	endif (BUILD_EXAMPLES)
endif (BUILD_FULL OR BUILD_STATIC)

if (BUILD_FULL OR BUILD_STATIC)
	add_subdirectory (benchmarks EXCLUDE_FROM_ALL)
endif (BUILD_FULL OR BUILD_STATIC)

ADD_CUSTOM_TARGET(uninstall
	"${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ElektraUninstall.cmake")

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/scripts/make-source-package.in"
	"${CMAKE_CURRENT_BINARY_DIR}/scripts/make-source-package")

ADD_CUSTOM_TARGET(source-package
		COMMAND "${CMAKE_CURRENT_BINARY_DIR}/scripts/make-source-package"
		COMMENT "Make a elektra source package by using git"
		VERBATIM
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
		)

=== benchmarks/CMakeLists.txt ===
include (LibAddMacros)

add_headers (HDR_FILES)

macro (do_benchmark source)
	include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")
	set (SOURCES ${HDR_FILES} benchmarks.c benchmarks.h ${source}.c)
	add_executable (${source} ${SOURCES})

	if (BUILD_FULL)
		target_link_libraries (${source} elektra-full)
	else (BUILD_FULL)
		target_link_libraries (${source} elektra-static)
	endif (BUILD_FULL)

	set_target_properties (${source} PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)

	get_target_property (command ${source} LOCATION)

	add_custom_target (benchmark
		rm -f *.out
		COMMAND valgrind --tool=callgrind --callgrind-out-file=callgrind.out "${command}" > output.out
		# COMMAND strace -o strace.out "${command}"
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
		)
endmacro (do_benchmark)

do_benchmark (large)

=== cmake/CMakeLists.txt ===
#ElektraPackaging needs to be included first (sets PACKAGE_ variables)

#cmake settings for use by find_package
configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/FindElektra.cmake.in"
		"${CMAKE_CURRENT_BINARY_DIR}/FindElektra.cmake"
		@ONLY
	)

install ( FILES
		"${CMAKE_CURRENT_BINARY_DIR}/FindElektra.cmake"
		DESTINATION ${TARGET_CMAKE_FOLDER}
	)

#pkg-config files
configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/elektra.pc.in"
		"${CMAKE_CURRENT_BINARY_DIR}/elektra.pc"
		@ONLY
	)

install ( FILES
		"${CMAKE_CURRENT_BINARY_DIR}/elektra.pc"
		DESTINATION lib${LIB_SUFFIX}/${TARGET_PKGCONFIG_FOLDER}
	)

=== doc/CMakeLists.txt ===
find_package(Doxygen)

# do_doc
#
#builds and install documentation
#
#target  is man, html or latex
#folder  is the folder where it will be built
#file    is the file name to set a depencency to
#install is where it should be installed
#
macro (do_doc target folder file install)
	add_custom_command (
		OUTPUT ${folder}/${file}
		COMMAND ${DOXYGEN_EXECUTABLE}
		ARGS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
	)

	#get_filename_component (name ${target} NAME_WE)

	add_custom_target (${target} ALL
		DEPENDS ${folder}/${file}
	)

	if (INSTALL_DOCUMENTATION)
		install (
			DIRECTORY ${folder}
			DESTINATION ${install}
		)
	endif (INSTALL_DOCUMENTATION)
endmacro (do_doc)

if (DOXYGEN_FOUND)
	set (OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

	if (BUILD_PDF)
		find_package(LATEX)
		if (LATEX_COMPILER)
			set (WITH_LATEX YES)
		else (LATEX_COMPILER)
			set (WITH_LATEX NO)
			message (WARNING "Latex not found, PDF Manual can't be created.")
		endif (LATEX_COMPILER)
	else (BUILD_PDF)
		set (WITH_LATEX NO)
	endif (BUILD_PDF)

	if (DOXYGEN_DOT_FOUND)
		set (WITH_DOT YES)
	else (DOXYGEN_DOT_FOUND)
		set (WITH_DOT NO)
	endif (DOXYGEN_DOT_FOUND)

	find_package(Perl)

	configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile"
		"${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
		@ONLY
	)

	do_doc(html ${OUTPUT_DIRECTORY}/html/ index.html
		${TARGET_DOCUMENTATION_HTML_FOLDER})
	do_doc(man ${OUTPUT_DIRECTORY}/man/man3elektra/ kdb.3elektra
		"${TARGET_DOCUMENTATION_MAN_FOLDER};PATTERN;_*;EXCLUDE")

	if (WITH_LATEX)
		do_doc(latex ${OUTPUT_DIRECTORY}/latex/ refman.tex
			${TARGET_DOCUMENTATION_LATEX_FOLDER})

		add_custom_command (
			OUTPUT ${OUTPUT_DIRECTORY}/latex/refman.pdf
			COMMAND ${PDFLATEX_COMPILER} ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			COMMAND ${PDFLATEX_COMPILER} ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			COMMAND ${PDFLATEX_COMPILER} ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			DEPENDS ${OUTPUT_DIRECTORY}/latex/refman.tex
			WORKING_DIRECTORY ${OUTPUT_DIRECTORY}/latex/
		)

		add_custom_target (pdf ALL
			DEPENDS ${OUTPUT_DIRECTORY}/latex/refman.pdf
		)
	endif (WITH_LATEX)
else (DOXYGEN_FOUND)
	message (WARNING "Doxygen not found, Reference Manual can't be created even though requested with BUILD_DOCUMENTATION.")
endif (DOXYGEN_FOUND)

=== examples/CMakeLists.txt ===
#project (examples)

#find_package (Elektra)

#if (ELEKTRA_FOUND)
#	include (${Elektra_USE_FILE})
#	add_executable (hello hello.c)
#	target_link_libraries (hello elektra)
#endif (ELEKTRA_FOUND)


include (LibAddMacros)

#don't call add_headers in a loop
add_headers (HDR_FILES)

macro (do_example source)
	include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")
	set (SOURCES ${HDR_FILES} ${source}.c)
	add_executable (${source} ${SOURCES})

	if (BUILD_FULL)
		target_link_libraries (${source} elektra-full)
	else (BUILD_FULL)
		target_link_libraries (${source} elektra-static)
	endif (BUILD_FULL)

	set_target_properties (${source} PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)
endmacro (do_example)

file (GLOB TESTS *.c)
foreach (file ${TESTS})
	get_filename_component (name ${file} NAME_WE)
	do_example (${name})
endforeach (file ${TESTS})

=== src/CMakeLists.txt ===
add_subdirectory (include)

add_subdirectory (liberror)

add_subdirectory (libloader)

add_subdirectory (plugins)

add_subdirectory (libelektra)

add_subdirectory (bindings)

add_subdirectory (libtools)

add_subdirectory (tools)

=== tests/CMakeLists.txt ===
## Elektra Test Suite
#
# This file is responsible for generating all tests
# regarding elektra's core.
#
# Backends and Bindings specific tests might be in
# their folders.
#
# To run all tests, simply type:
#  make test
#
# To run specific tests, type:
#  ctest -R name
#
# To run tests with valgrind, type:
#  ctest -T memcheck
#
# To run verbose (to see output and commands), type:
#  ctest -V
#
# For example, to run keyset test with valgrind and verbose, type:
#  ctest -V -T memcheck -R ks
#
##

include (LibAddMacros)

#don't call add_headers in a loop
add_headers (HDR_FILES)

macro (do_test source)
	include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")
	set (SOURCES ${HDR_FILES} ${source}.c tests.c)
	add_executable (${source} ${SOURCES})

	if (INSTALL_TESTING)
		install (TARGETS ${source}
			DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
	endif (INSTALL_TESTING)

	if (BUILD_FULL)
		target_link_libraries (${source} elektra-full)
	else (BUILD_FULL)
		target_link_libraries (${source} elektra-static)
	endif (BUILD_FULL)

	set_target_properties (${source} PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)
	set_target_properties (${source} PROPERTIES LINKER_LANGUAGE CXX)
	add_test (${source}
			"${PROJECT_BINARY_DIR}/tests/${source}"
			"${PROJECT_BINARY_DIR}/tests"
			)
endmacro (do_test)

file (GLOB TESTS test_*.c)
foreach (file ${TESTS})
	get_filename_component (name ${file} NAME_WE)
	do_test (${name})
endforeach (file ${TESTS})

add_subdirectory (shell)

include_directories ("${PROJECT_SOURCE_DIR}/tests")

=== src/bindings/CMakeLists.txt ===
add_subdirectory (cpp)

if (BUILD_SWIG)
	find_package(SWIG 2 REQUIRED)
endif (BUILD_SWIG)

if (BUILD_SWIG_LUA)
	set (TARGET_LUA_CMOD_FOLDER "lib${LIB_SUFFIX}/lua/5.2"
		CACHE PATH
		"Directory to install Lua binary modules (configure lua via LUA_CPATH)"
	)
endif (BUILD_SWIG_LUA)

if (SWIG_FOUND)
	add_subdirectory (swig)
endif (SWIG_FOUND)

=== src/include/CMakeLists.txt ===
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckTypeSize)

check_symbol_exists(clearenv     "stdlib.h"         HAVE_CLEARENV)
check_symbol_exists(setenv       "stdlib.h"         HAVE_SETENV)

check_include_file(ctype.h      HAVE_CTYPE_H)
check_include_file(errno.h      HAVE_ERRNO_H)
check_include_file(locale.h     HAVE_LOCALE_H)
check_include_file(stdio.h      HAVE_STDIO_H)
check_include_file(stdlib.h     HAVE_STDLIB_H)
check_include_file(string.h     HAVE_STRING_H)
check_include_file(time.h       HAVE_TIME_H)
check_include_file(unistd.h     HAVE_UNISTD_H)

check_type_size(int             SIZEOF_INT)
check_type_size(long            SIZEOF_LONG)
check_type_size("long long"     SIZEOF_LONG_LONG)
check_type_size("long double"   SIZEOF_LONG_DOUBLE)

set (BUILTIN_EXEC_FOLDER
	"${CMAKE_INSTALL_PREFIX}/${TARGET_TOOL_EXEC_FOLDER}")
set (BUILTIN_DATA_FOLDER
	"${CMAKE_INSTALL_PREFIX}/${TARGET_TEST_DATA_FOLDER}")
set (ELEKTRA_DEPRECATED "__attribute__ ((deprecated))")
set (ELEKTRA_UNUSED "__attribute__ ((unused))")

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdb.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/kdb.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbconfig.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbconfig.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbversion.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbversion.h"
	)

install (FILES
	"${CMAKE_CURRENT_BINARY_DIR}/kdbconfig.h"
	kdbextension.h
	kdbtypes.h
	"${CMAKE_CURRENT_BINARY_DIR}/kdb.h"
	kdbinternal.h
	kdbmodule.h
	kdbos.h
	kdbplugin.h
	kdbprivate.h
	kdbtools.h
	"${CMAKE_CURRENT_BINARY_DIR}/kdbversion.h"
	DESTINATION include/${TARGET_INCLUDE_FOLDER})

=== src/libelektra/CMakeLists.txt ===
# For static inclusion of libraries we need a list
# of symbols to make the static runtime linker work.
#
# For that there is the program exportsymbols which
# generates the sourcefiles exported_symbols.h
# and exported_symbols.c containing an array of
# all symbols.
#
# The program needs a list of all backends as
# argument.
#
# Symbols of libelektratools will be treaded specially.
add_executable (exportsymbols exportsymbols.c)

if (CMAKE_CROSSCOMPILING)
	find_program (EXE_SYM_LOC exportsymbols)
else (CMAKE_CROSSCOMPILING)
	get_target_property (EXE_SYM_LOC exportsymbols LOCATION)
endif (CMAKE_CROSSCOMPILING)

add_custom_command (
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.h
		DEPENDS exportsymbols
		COMMAND ${EXE_SYM_LOC}
		ARGS ${PLUGINS}
		)

add_custom_command (
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.c
		DEPENDS exportsymbols
		COMMAND ${EXE_SYM_LOC}
		ARGS ${PLUGINS}
		)


# Include the shared header files of the elektra project
include(LibAddMacros)
add_headers(HDR_FILES)
# not always needed.. only with cppplugins
add_cppheaders(HDR_FILES)

#include the current binary directory to get exported_symbols.h
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

#now add all source files of this folder
file (GLOB SRC_FILES *.c)

#remove those we don't want..
file (GLOB RM_FILES exportsymbols.c kdbmainpage.c)
list (REMOVE_ITEM SRC_FILES ${RM_FILES})

#now add all source files of other folders
get_property (elektra_SRCS GLOBAL PROPERTY elektra_SRCS)
list (APPEND SRC_FILES ${elektra_SRCS})

set (SOURCES ${SRC_FILES} ${HDR_FILES})
list (APPEND SOURCES "${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.h")


if (BUILD_SHARED)
	get_property (elektra-shared_SRCS GLOBAL PROPERTY elektra-shared_SRCS)
	add_library (elektra SHARED ${SOURCES} ${elektra-shared_SRCS})

	get_property (elektra-shared_LIBRARIES GLOBAL PROPERTY elektra-shared_LIBRARIES)
	target_link_libraries (elektra ${elektra-shared_LIBRARIES})

	get_property (elektra-shared_INCLUDES GLOBAL PROPERTY elektra-shared_INCLUDES)
	include_directories (${elektra-shared_INCLUDES})

	set_target_properties (elektra PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)
	set_target_properties (elektra PROPERTIES
			VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION})
	set_target_properties (elektra PROPERTIES CLEAN_DIRECT_OUTPUT 1)

	#search only in the prefix the user decided to install elektra
	#(e.g. /usr/local/)
	set (ELEKTRA_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER}")

	#RPATH settings, see http://www.itk.org/Wiki/CMake_RPATH_handling
	#those settings are needed to find the plugins at runtime even without ld.so.conf
	set_target_properties ( elektra PROPERTIES INSTALL_RPATH "${ELEKTRA_RPATH}")

	install (TARGETS elektra DESTINATION lib${LIB_SUFFIX})
endif (BUILD_SHARED)

if (BUILD_FULL OR BUILD_STATIC)
	#for the next two builds, append some more sources
	get_property (elektra-full_SRCS GLOBAL PROPERTY elektra-full_SRCS)
	list (APPEND SOURCES ${elektra-full_SRCS}
		${BINARY_INCLUDE_DIR}/kdberrors.h)
	list (APPEND SOURCES "${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.c")

	#and get all libraries to link against
	get_property (elektra-full_LIBRARIES GLOBAL PROPERTY elektra-full_LIBRARIES)

	# include the directories of all libraries for the static or
	# full-shared build
	get_property (elektra-full_INCLUDES GLOBAL PROPERTY elektra-full_INCLUDES)

	include_directories (${elektra-full_INCLUDES})
endif (BUILD_FULL OR BUILD_STATIC)


if (BUILD_FULL)
	add_library (elektra-full SHARED ${SOURCES})

	target_link_libraries (elektra-full ${elektra-full_LIBRARIES})

	set_target_properties (elektra-full PROPERTIES
			COMPILE_DEFINITIONS "HAVE_KDBCONFIG_H;ELEKTRA_STATIC")
	set_target_properties (elektra-full PROPERTIES
			VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION})
	set_target_properties (elektra-full PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	set_target_properties (elektra-full PROPERTIES LINKER_LANGUAGE CXX)

	install (TARGETS elektra-full DESTINATION lib${LIB_SUFFIX})
endif (BUILD_FULL)


if (BUILD_STATIC)
	add_library (elektra-static STATIC ${SOURCES})

	target_link_libraries (elektra-static ${elektra-full_LIBRARIES})

	set_target_properties (elektra-static PROPERTIES
			COMPILE_DEFINITIONS "HAVE_KDBCONFIG_H;ELEKTRA_STATIC")
	set_target_properties (elektra-static PROPERTIES
			VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION})
	set_target_properties (elektra-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	set_target_properties (elektra-static PROPERTIES LINKER_LANGUAGE CXX)

	install (TARGETS elektra-static DESTINATION lib${LIB_SUFFIX})
endif (BUILD_STATIC)

#if you want the same name for those 3 libraries, here is how to do it:
#http://www.itk.org/Wiki/CMake_FAQ#How_do_I_make_my_shared_and_static_libraries_have_the_same_root_name.2C_but_different_suffixes.3F

=== src/liberror/CMakeLists.txt ===
add_executable(exporterrors exporterrors.cpp parser.hpp parser.cpp)

set_source_files_properties(exporterrors OBJECT_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/specification)

=== src/libloader/CMakeLists.txt ===
include (LibAddMacros)

add_sources (elektra-full "static.c")

if (BUILD_SHARED)
	find_package (DL REQUIRED)
	if (DL_FOUND)
		add_sources (elektra-shared "dl.c")
		add_includes (elektra-shared ${DL_INCLUDE_DIRS})
		add_libraries (elektra-shared ${DL_LIBRARIES})
	else (DL_FOUND)
		message (ERROR "dl not found and no other module mechanism currently defined, see src/libloader")
	endif (DL_FOUND)
endif (BUILD_SHARED)

## elektra 0.7.0

=== debian/changelog ===
elektra (0.7.0-3) unstable; urgency=low

  * debian/patches:
    - add patch 01_spelling_fixes.diff to fix spelling errors found in API
      documentation
  * debian/control:
    - make elektra-bin conflict with kernel-patch-kdb, as both install
      /usr/share/man/man1/kdb.1.gz (Closes: #595221)
  * debian/libelektra-cpp0.symbols:
    - update for sparc64

 -- Pino Toscano <pino@kde.org>  Wed, 08 Sep 2010 23:34:19 +0200

elektra (0.7.0-2) unstable; urgency=low

  * debian/libelektra-cpp0.symbols:
    - take into account the various manglings of va_list, size_t and mode_t,
      and other architecture/OS-specific symbols (Closes: #594869)
  * debian/control:
    - make libelektra-dev conflict with libkrb5-dev, as both install
      /usr/include/kdb.h
  * debian/copyright:
    - clarify license of src/backends/gconf/gconf.c, which is GPLv2+

 -- Pino Toscano <pino@kde.org>  Tue, 31 Aug 2010 13:19:08 +0200

elektra (0.7.0-1) unstable; urgency=low

  * Initial release.

 -- Pino Toscano <pino@kde.org>  Tue, 24 Aug 2010 23:47:03 +0200

=== debian/control ===
Source: elektra
Section: misc
Priority: optional
Maintainer: Pino Toscano <pino@kde.org>
Build-Depends: debhelper (>= 7.0.50~),
 pkg-config (>= 0.9.0),
 docbook-xml,
 docbook-xsl,
 doxygen,
 graphviz,
 xsltproc,
 libxml2-dev,
 libltdl-dev,
Standards-Version: 3.9.1
Homepage: http://www.libelektra.org/
DM-Upload-Allowed: yes

Package: libelektra3
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: elektra-doc
Description: the Elektra configuration store, main library
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the main elektra library, and the 'filesys' and 'hosts'
 backends.

Package: libelektra-dev
Section: libdevel
Architecture: any
Depends: libelektra3 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: libkrb5-dev
Description: the Elektra configuration store, main library [development]
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the development files for the main elektra library.

Package: libelektratools2
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: the Elektra configuration store, elektratools library
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the elektratools library, which is used to deserialize
 keys from XML and serialize them to XML.

Package: libelektratools-dev
Section: libdevel
Architecture: any
Depends: libelektratools2 (= ${binary:Version}),
 libelektra-dev (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: the Elektra configuration store, elektratools library [development]
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the development files for the elektratools library.

Package: libelektra-cpp0
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: the Elektra configuration store, CPP binding
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the CPP binding for the Elektra library.

Package: libelektra-cpp-dev
Section: libdevel
Architecture: any
Depends: libelektra-cpp0 (= ${binary:Version}),
 libelektra-dev (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: the Elektra configuration store, CPP binding [development]
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the development files for the CPP binding of the
 Elektra library.

Package: elektra-bin
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Conflicts: kernel-patch-kdb
Description: the Elektra configuration store, binaries
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains command line utilities for Elektra.

Package: elektra-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: the Elektra configuration store, API documentation
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the API documentation for the Elektra libraries.

## elektra 0.7.1

=== debian/changelog ===
elektra (0.7.1-1) unstable; urgency=low

  * New upstream release.
  * debian/libelektra-cpp0.symbols:
    - small updates

 -- Pino Toscano <pino@debian.org>  Fri, 26 Aug 2011 12:29:24 +0200

elektra (0.7.0-4) unstable; urgency=low

  * debian/control:
    - bump Standards-Version to 3.9.2, no changes required
    - switch to my @debian.org address, I'm a DD now
    - remove DM-Upload-Allowed, no more useful now
    - remove articles from the start of the short descriptions
  * debian/copyright:
    - small update of the packaging information
  * debian/libelektra-cpp0.symbols:
    - mark template instantiation symbols (Closes: #625194)
    - update for s390x

 -- Pino Toscano <pino@debian.org>  Sun, 14 Aug 2011 00:24:11 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: elektra
 Section: misc
 Priority: optional
-Maintainer: Pino Toscano <pino@kde.org>
+Maintainer: Pino Toscano <pino@debian.org>
 Build-Depends: debhelper (>= 7.0.50~),
  pkg-config (>= 0.9.0),
  docbook-xml,
@@ -11,9 +11,8 @@
  xsltproc,
  libxml2-dev,
  libltdl-dev,
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://www.libelektra.org/
-DM-Upload-Allowed: yes
 
 Package: libelektra3
 Section: libs
@@ -21,7 +20,7 @@
 Depends: ${shlibs:Depends},
  ${misc:Depends}
 Suggests: elektra-doc
-Description: the Elektra configuration store, main library
+Description: elektra configuration store, main library
  Elektra provides a universal and secure framework to store configuration
  parameters in a hierarchical key-value pair mechanism, instead of each
  program using its own text configuration files. This allows any program
@@ -41,7 +40,7 @@
  ${shlibs:Depends},
  ${misc:Depends}
 Conflicts: libkrb5-dev
-Description: the Elektra configuration store, main library [development]
+Description: elektra configuration store, main library [development]
  Elektra provides a universal and secure framework to store configuration
  parameters in a hierarchical key-value pair mechanism, instead of each
  program using its own text configuration files. This allows any program
@@ -58,7 +57,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
  ${misc:Depends}
-Description: the Elektra configuration store, elektratools library
+Description: elektra configuration store, elektratools library
  Elektra provides a universal and secure framework to store configuration
  parameters in a hierarchical key-value pair mechanism, instead of each
  program using its own text configuration files. This allows any program
@@ -78,7 +77,7 @@
  libelektra-dev (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
-Description: the Elektra configuration store, elektratools library [development]
+Description: elektra configuration store, elektratools library [development]
  Elektra provides a universal and secure framework to store configuration
  parameters in a hierarchical key-value pair mechanism, instead of each
  program using its own text configuration files. This allows any program
@@ -95,7 +94,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
  ${misc:Depends}
-Description: the Elektra configuration store, CPP binding
+Description: elektra configuration store, CPP binding
  Elektra provides a universal and secure framework to store configuration
  parameters in a hierarchical key-value pair mechanism, instead of each
  program using its own text configuration files. This allows any program
@@ -114,7 +113,7 @@
  libelektra-dev (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
-Description: the Elektra configuration store, CPP binding [development]
+Description: elektra configuration store, CPP binding [development]
  Elektra provides a universal and secure framework to store configuration
  parameters in a hierarchical key-value pair mechanism, instead of each
  program using its own text configuration files. This allows any program
@@ -132,7 +131,7 @@
 Depends: ${shlibs:Depends},
  ${misc:Depends}
 Conflicts: kernel-patch-kdb
-Description: the Elektra configuration store, binaries
+Description: elektra configuration store, binaries
  Elektra provides a universal and secure framework to store configuration
  parameters in a hierarchical key-value pair mechanism, instead of each
  program using its own text configuration files. This allows any program
@@ -148,7 +147,7 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
-Description: the Elektra configuration store, API documentation
+Description: elektra configuration store, API documentation
  Elektra provides a universal and secure framework to store configuration
  parameters in a hierarchical key-value pair mechanism, instead of each
  program using its own text configuration files. This allows any program

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	  --with-dbackend=filesys \
	  --with-backenddir=\$${libdir}/elektra3 \
	  --with-develdocdir=\$${datadir}/doc/elektra-doc \
	  --with-docbook=/usr/share/xml/docbook/stylesheet/nwalsh

override_dh_install:
	dh_install --list-missing -X.la

.PHONY: override_dh_auto_test

=== debian/watch ===
version=3
http://sf.net/elektra/elektra-(.*)\.tar\.gz

## elektra 0.7.2

=== debian/changelog ===
elektra (0.7.2-2) unstable; urgency=medium

  * Update symbols files for arm64 and ppc64el.
  * Fix typo in copyright (thanks to Markus Raab).
  * Update patch 01_spelling_fixes.diff to cover also "transfered".

 -- Pino Toscano <pino@debian.org>  Sat, 19 Jul 2014 09:15:04 +0200

elektra (0.7.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump the debhelper compatibility to 9:
    - bump compat to 9
    - bump the debhelper build dependency to >= 9
    - keep the libdir as $prefix/lib for now, will revise it regarding
      multiarch in a later step
    - exclude the plugins from the shlibs handling
  * Enable the parallel build.
  * Update watch file, adding the new location.
  * Do the autoreconf at build time: (Closes: #727372, #744568)
    - add the dh-autoreconf build dependency
    - use the autoreconf dh addon
    - touch config.rpath before autoreconf'ing, workaround for some autotools
      issue
    - make sure to disable the ltdl installation, so the system libltdl is used
    - add docdata_install.diff patch to fix apidox installation
  * Update symbols files, including the fixes for mips64(el) (thanks to
    YunQiang Su) and ppc64 (thanks to Hiroyuki Yamamoto).
    (Closes: #669969, #726129)
  * Bump Standards-Version to 3.9.5, no changes required.
  * Add Vcs-* headers in control.
  * Update copyright.

 -- Pino Toscano <pino@debian.org>  Sat, 12 Jul 2014 17:46:05 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: misc
 Priority: optional
 Maintainer: Pino Toscano <pino@debian.org>
-Build-Depends: debhelper (>= 7.0.50~),
+Build-Depends: debhelper (>= 9),
+ dh-autoreconf,
  pkg-config (>= 0.9.0),
  docbook-xml,
  docbook-xsl,
@@ -11,8 +12,10 @@
  xsltproc,
  libxml2-dev,
  libltdl-dev,
-Standards-Version: 3.9.2
+Standards-Version: 3.9.5
 Homepage: http://www.libelektra.org/
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/pino/elektra.git
+Vcs-Git: git://anonscm.debian.org/users/pino/elektra.git
 
 Package: libelektra3
 Section: libs

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --parallel --with autoreconf

override_dh_clean:
	dh_clean
	rm -f config.rpath

override_dh_autoreconf:
	touch config.rpath
	dh_autoreconf

override_dh_auto_configure:
	dh_auto_configure -- \
	  --libdir=\$${prefix}/lib \
	  --with-dbackend=filesys \
	  --with-backenddir=\$${libdir}/elektra3 \
	  --with-develdocdir=\$${datadir}/doc/elektra-doc \
	  --with-docbook=/usr/share/xml/docbook/stylesheet/nwalsh \
	  --enable-ltdl-install=no

override_dh_install:
	dh_install --list-missing -X.la

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/elektra3

.PHONY: override_dh_auto_test
